Doom64TC does not have a fully functional HUD
2015-05-02 23:12 - rhargrave

Status: Progressed Start date: 2015-05-02
Priority: Normal % Done: 80%
Assignee: rhargrave

Category: User experience

Target version: Modding

Description

This is likely the cause of #2019.

ST_BuildWidgets in doom64/src/st_stuff.c only initializes the automap.
It does not initialize the log, chat, status bar, etc...

Related issues:

Related to Bug #2019: ST_UlLogForPlayer returning garbage in jDoom64 Closed 2015-04-30
Related to Bug #2024: doom64 plugin does not draw HUD Closed 2015-05-02
History

#1 - 2015-05-03 00:29 - rhargrave

- Tags changed from Doom64TC to Doom64TC, HUD

- Subject changed from Doom64TC plugin does not fully initialize HUD widgets to Doom64TC does not have a fully functional HUD
- % Done changed from 0 to 10

I've added the log (and chat) widget to the HUD, which has effectively stopped the crash-on-LogPost bug from happening. As it stands right now,
however, the HUD is not being rendered. I've checked that Hu_Drawer is being called, and it is. I'll debug this and check back.

#2 - 2015-05-03 00:30 - rhargrave
- Related to Bug #2019: ST_UlLogForPlayer returning garbage in jDoom64 added

#3 - 2015-05-03 09:41 - rhargrave

It looks like the HUD drawing logic that is present (and obviously not working) is all spread throughout “st_stuff'. Once | finish migrating this to C++, I'll
refactor it all out and see about better HUD support.

#4 - 2015-05-03 10:11 - danij

I have just pushed a hud-cleanup work branch which | started a month or so back where | began doing just that. You may want to continue or adapt
that work as it'll likely save you a fair amount of time.

With regards to the HUD, please bear in mind that we plan to replace the implementation entirely using libgui components. A primary goal for any
cleanup work should therefore be code clarity. As opposed to best OO practices, code-quality concerns, etc...

#5 - 2015-05-03 11:37 - skyjake

danij wrote:

we plan to replace the implementation entirely using libgui components

To clarify what this means:

e libgui is where the low-level OpenGL code resides. It does not contain any higher-level Ul widget functionality.

¢ The new Ul widgets in libappfw do their drawing using the OpenGL classes in libgui. These are the ones responsible for the engine Ul overlay
(task bar, console log, FPS indicator, etc.). This is completely engine-side functionality currently, because the game plugins have their own Ul
drawing code, including a simple widget system.

e There is a plan to replace the game plugins' menu system with one based on InFine and Doomsday Script (#1630).

* | am not aware of a concrete plan (in the tracker) for exactly how the game HUD widgets should be reworked. Having a direct dependency from
libgui to the plugins is not advisable because game plugins must be compilable also in a server-only configuration. That's why there is currently
the DGL API published by the engine (which provides a simple OpenGL 1 like drawing API), which is only offered to plugins by the client
executable.
#6 - 2015-05-03 11:54 - danij

Indeed | should have been clearer. The plan is not to literally base the game side HUD widgets directly on top of libgui components. My usage being
rather colloquial, there.

#7 - 2015-05-03 14:08 - skyjake
- Related to Bug #2024: doom64 plugin does not draw HUD added

#8 - 2015-05-07 18:41 - rhargrave
- % Done changed from 10 to 50

I've finished integrating Danid's HUD. All that appears to be necessary at the moment is to debug a rendering issue that results in the HUD being
rendered starting at the bottom of the display.

#9 - 2015-05-07 22:01 - rhargrave
- % Done changed from 50 to 80

I've got the HUD working, the bug that was borking the render had to do with the order in which it was initialized. All that's left now is to insure that it is
fully functional and spot any other bugs.

#10 - 2015-05-07 22:03 - rhargrave

- Related to Feature #4: Ul improvements added

#11 - 2015-05-07 22:04 - rhargrave

I've marked this as being related to #4 (Ul Renovation) since implementing the 64TC hud effectively involved implementing DaniJ's HUD widget

system for all engine plugins.

#12 - 2015-05-07 22:26 - rhargrave
- File doom64-013.png added

I've attached a picture of the HUD. It is notably more similary to D64EX than D64TC. The keys are currently not displayed -- | will fix that, however.

#13 - 2016-07-06 09:25 - skyjake

- Status changed from New to Progressed

#14 - 2019-11-29 15:32 - skyjake

- Related to deleted (Feature #4: Ul improvements)

#15 - 2019-11-29 21:57 - skyjake

- Target version set to Modding

Files
